<template>
<st-content heading="Seguimiento de sesiones">
<div>
  <div class="content-body">

    <div class="table-heading">
      <v-row justify="start">
      <st-search
        text="Buscar por nombre de sesión de tutoría"
        @enter="search($event)"
      />
     <!-- <v-col md="4">
        <st-select
          nombre = "Estado de la sesión de tutoría"
          :items = "estados"
          itemText = nombre
          itemValue = nombre
          @cambioNombre="cambioPadre"
          :value = "estado"
        />
      </v-col>-->

    </v-row>
    </div>


    <!--<v-row>
      <v-col md="4">
      <st-date-picker
        nombre = "Periodo"
      />
      </v-col>
    </v-row>-->
     <v-data-table
    v-bind="{ headers,items }"
    :hide-default-footer="items.length <= 10"
    
    :loading="loading"
    loading-text="Cargando..."
    no-data-text="No se encontraron resultados"
    no-results-text="No se encontraron resultados"
    :sort-by="['fecha']"
    :sort-desc="[true]"
    :items-per-page="itemsPerPage"
    @click:row = "details"
  >
  <template
            v-slot:item.fecha="{ item }" >
    {{ item.fecha | formatDate }}
  </template>
  
     </v-data-table>
  </div>
</div>
 <v-row justify="center">
    <v-dialog v-model="dialog" persistent width="400">
      <v-card>
         
        <v-card-title class="headline"><v-col>{{ titulo}}</v-col></v-card-title>
        
        <v-card-text><v-col>{{texto}}</v-col></v-card-text>
        
        <v-card-actions >
            <v-row no-gutters justify="end">
        <v-spacer></v-spacer> 

          <v-btn color="primary" text @click="dialog = false">Volver</v-btn>
          <v-btn v-if="positive" color="secondary" text @click="acceptApp">{{accion}}</v-btn>
          <v-btn v-else color="secondary" text @click="cancelApp">{{accion}}</v-btn>
            </v-row>
        </v-card-actions>

      </v-card>
    </v-dialog>
  </v-row>
</st-content>
</template>

<script>
import DataTable from '@/components/DataTable'
import Select from '@/components/Select'
import DatePicker from '@/components/DatePicker'
import Search from '@/components/Search'
export default {
  data () {
    return{
        positive : true,
    dialog: false,
    titulo : "",
    texto : "",
    accion: "",
      item: {},
      itemsPerPage : 10,
      estado: 'Solicitado',
      items: [],
      estados: [],
      loading:false,
      idTutor : '80dd6af9-20f9-4099-98cb-fa2b1d167645',
      path:{
        url: '/tutor/tutorias/',
        id: 'idSession'
      },
      headers: [
        {
          text: 'Nombre de la tutoría',
          align: 'start',
          sortable: false,
          value: 'nombreTutoria',
        },
        {
          text: 'Alumno',
          sortable: false,
          value: 'alumno'
        },
        {
          text: 'Fecha y Hora de Inicio',
          value: 'fecha'
        }
      ],
      filters:{
        search:'',
        estadoTut:'',
      }
    }
  },
  components: {
    'st-data-table' : DataTable,
    'st-select' : Select,
    'st-date-picker': DatePicker,
    'st-search': Search,
  },
  filters: {
    formatDate: function(value){
      if(!value) return "Cargando...";
      let options = { year: 'numeric', month: 'long', day: 'numeric', hour12: 'true',timeStyle: 'short', dateStyle: 'long'}
      let d = new Date(value).toLocaleTimeString('es', options)
      return d
    }
  },
  methods: {
    details(value){
      let path = this.path.url + value[this.path.id]
      this.$router.push(path)
    },
    imprimir(){
    },
    cambioPadre(dato){
      this.filters.estadoTut = dato;
      if(dato == "Todos") this.estado = "";
      else this.estado = dato;
    },
    async ini(){
      this.loading = true
      try {
        this.estados.push({nombre: 'Todos'})
        let { data: { data:{sesiones} } } = await this.$api.getTutorSessions(this.$store.state.role.id)
        this.items = sesiones
        let aux = [...this.items]
        this.items =  []
        let aux2 = {}
        for(let it in aux){
            if(aux[it].estado === "Atendido" && aux[it].segimiento){
                let aux2 = {}
                Object.assign(aux2, aux[it])
                this.items.push(aux2)
            }
        }
      } catch (error) {
        this.$store.commit("setError", error);
      }
      this.loading = false
    },
    async search(value){
      this.loading = true
      try {
        let { data: { data:{sesiones} } } = await this.$api.getTutorSessions(this.$store.state.role.id, value)
        this.items = sesiones
        
        
      } catch (error) {
        this.$store.commit("setError", error);
      }
      this.loading = false
    },
    addName(nombre){
      return 'XD :v'
    },
    accept(item){
        this.positive = true
        this.dialog = true
        this.titulo = "Aceptar cita"
        this.texto = "Está a punto de aceptar la cita. Puede cancelarlo en cualquier momento en el historial de citas."
        this.accion = "Aceptar cita"
        this.item = item
    },
    cancel(item){
        this.positive = false
        this.dialog = true
        this.titulo = "Cancelar cita"
        this.texto = "¿Está seguro de cancelar la cita? Recuerde que esto es un proceso irreversible."
        this.accion = "Cancelar cita"
        this.item = item
    },
    async acceptApp(){
      // this.aux = this.$refs.sessionResult.imprimir();
       let data = {     
          "sesion":{
              "fechaInicio": "",//this.sesion.datos.fechaInicio, //Opcional
              "fechaFin":"",//new Date().toISOString().substr(0,19) + "-05:00",// "2020-07-10T15:00:00Z", //Opcional
              "comentario" : "",//this.aux.comentario,//"El alumno requiere soporte con algunos cursos", //Opcional
              "derivación": "",//true,//Opcional
              "idUnidadDerivada": "",//this.aux.derivacion,//"id-id-id-id", //Opcional
              "idEstado": "Pendiente"
            },
            "planDeAccion":  [],//this.aux.planDeAccion
      }
      try {
          let response = await this.$api.updateSession(this.item.idSession, data)
          this.ini()

        //this.$emit('refresh',{ response: response})
        
      } catch (e) {        
        this.$store.commit('setError', e)
      }
      this.dialog = false
    },
    async cancelApp(){
         let data = {     
          "sesion":{
              "fechaInicio": "",//this.sesion.datos.fechaInicio, //Opcional
              "fechaFin":"",//new Date().toISOString().substr(0,19) + "-05:00",// "2020-07-10T15:00:00Z", //Opcional
              "comentario" : "",//this.aux.comentario,//"El alumno requiere soporte con algunos cursos", //Opcional
              "derivación": "",//true,//Opcional
              "idUnidadDerivada": "",//this.aux.derivacion,//"id-id-id-id", //Opcional
              "idEstado": "Cancelado"
            },
            "planDeAccion":  [],//this.aux.planDeAccion
      }
      try {
         let response = await this.$api.updateSession(this.item.idSession, data)
         this.ini()
        //this.$emit('refresh',{ response: response})
        
      } catch (e) {        
        this.$store.commit('setError', e)
      }
      this.dialog = false
    }

  },
  mounted () {
    this.ini()
    //window.addEventListener('keyup', (event) =>  {
    //  if (event.keyCode === 13) {
    //    this.imprimir()
    //  }
    //});
  },
  computed : {
  
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
